"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t;
    return { next: verb(0), "throw": verb(1), "return": verb(2) };
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var pathToRegexp = require("path-to-regexp");
var queryString = require("query-string");
exports.parseQuery = function (query) { return queryString.parse(query); };
exports.stringifyQuery = function (query) { return queryString.stringify(query); };
var createLocation = function (path) {
    var parsedPath = parsePath(path);
    return __assign({}, parsedPath, { query: exports.parseQuery(parsedPath.search) });
};
var parsePath = function (path) {
    var pathname = path || '/';
    var search = '';
    var hash = '';
    var hashIndex = pathname.indexOf('#');
    if (hashIndex !== -1) {
        hash = pathname.substr(hashIndex);
        pathname = pathname.substr(0, hashIndex);
    }
    var searchIndex = pathname.indexOf('?');
    if (searchIndex !== -1) {
        search = pathname.substr(searchIndex);
        pathname = pathname.substr(0, searchIndex);
    }
    return {
        pathname: pathname,
        search: search === '?' ? '' : search,
        hash: hash === '#' ? '' : hash
    };
};
function trimSlashes(str) {
    return str.replace(/^\/+|\/+$/g, '');
}
function decodeParam(val) {
    if (val === undefined || val === '') {
        return val;
    }
    try {
        return decodeURIComponent(val);
    }
    catch (err) {
        return val;
    }
}
var RouterError = (function () {
    function RouterError(message, status) {
        if (message === void 0) { message = 'Internal Error'; }
        if (status === void 0) { status = 500; }
        this.message = message;
        this.status = status;
    }
    return RouterError;
}());
exports.RouterError = RouterError;
var DynamicRedirect = (function () {
    function DynamicRedirect(path, status) {
        if (status === void 0) { status = 302; }
        this.path = path;
        this.status = status;
    }
    return DynamicRedirect;
}());
exports.DynamicRedirect = DynamicRedirect;
var Context = (function () {
    function Context() {
        this.keys = {};
    }
    Context.prototype.set = function (key, value) {
        if (key in this.keys) {
        }
        else {
            this.keys[key] = value;
        }
    };
    Context.prototype.get = function (key) {
        if (key in this.keys) {
            return this.keys[key];
        }
        else {
            return null;
        }
    };
    Context.prototype.toObject = function () {
        return __assign({}, this.keys);
    };
    return Context;
}());
exports.Context = Context;
var Transition = (function () {
    function Transition() {
        this.isCancelled = false;
    }
    Transition.prototype.cancel = function () {
        this.isCancelled = true;
    };
    Transition.prototype.runOrResolve = function (path, ctx, isHooks, router) {
        var _this = this;
        var location = createLocation(path);
        var redirectHistory = new Map();
        var doRunOrResolve = function (path, location, ctx, redirect, status) {
            if (redirect === void 0) { redirect = null; }
            if (status === void 0) { status = null; }
            return __awaiter(_this, void 0, void 0, function () {
                var resultStartHooks, matchResult, route, params, error, resultMatchHooks, result, status_1, redirect_1, error_1, resultResolveHooks;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, router.runHooks('start', this, { path: path, location: location, ctx: ctx }, isHooks)];
                        case 1:
                            resultStartHooks = _a.sent();
                            if (resultStartHooks !== null)
                                return [2 /*return*/, resultStartHooks];
                            return [4 /*yield*/, router.match({ path: path, ctx: ctx })];
                        case 2:
                            matchResult = _a.sent();
                            route = matchResult.route, params = matchResult.params, error = matchResult.error;
                            if (redirect === null) {
                                redirect = matchResult.redirect;
                                status = matchResult.status;
                            }
                            if (!(error !== null)) return [3 /*break*/, 4];
                            return [4 /*yield*/, router.handleError({ path: path, location: location, route: null, status: error.status, params: null, redirect: null, result: null, ctx: ctx, error: error }, this, isHooks)];
                        case 3: return [2 /*return*/, _a.sent()];
                        case 4: return [4 /*yield*/, router.runHooks('match', this, { path: path, location: location, route: route, status: status, params: params, redirect: redirect, ctx: ctx }, isHooks)];
                        case 5:
                            resultMatchHooks = _a.sent();
                            if (resultMatchHooks !== null)
                                return [2 /*return*/, resultMatchHooks];
                            result = null;
                            if (!!this.isCancelled) return [3 /*break*/, 7];
                            return [4 /*yield*/, route.action({ path: path, location: location, route: route, status: status, params: params, redirect: redirect, ctx: ctx, helpers: router.helpers })];
                        case 6:
                            result = _a.sent();
                            _a.label = 7;
                        case 7:
                            if (!(result instanceof RouterError)) return [3 /*break*/, 9];
                            return [4 /*yield*/, router.handleError({ path: path, location: location, route: route, status: result.status, params: params, redirect: redirect, result: null, ctx: ctx, error: result }, this, isHooks)];
                        case 8: return [2 /*return*/, _a.sent()];
                        case 9:
                            if (!(result instanceof DynamicRedirect)) return [3 /*break*/, 12];
                            status_1 = result.status;
                            redirect_1 = result.path;
                            if (!redirectHistory.has(route)) return [3 /*break*/, 11];
                            error_1 = new RouterError('Circular Redirect', 500);
                            return [4 /*yield*/, router.handleError({ path: path, location: location, route: route, status: error_1.status, params: params, redirect: redirect_1, result: null, ctx: ctx, error: error_1 }, this, isHooks)];
                        case 10: return [2 /*return*/, _a.sent()];
                        case 11:
                            redirectHistory.set(route, true);
                            return [2 /*return*/, doRunOrResolve(redirect_1, location, ctx, redirect_1, status_1)];
                        case 12: return [4 /*yield*/, router.runHooks('resolve', this, { path: path, location: location, route: route, status: status, params: params, redirect: redirect, result: result, ctx: ctx }, isHooks)];
                        case 13:
                            resultResolveHooks = _a.sent();
                            if (resultResolveHooks !== null)
                                return [2 /*return*/, resultResolveHooks];
                            return [2 /*return*/, { path: path, location: location, route: route, status: status, params: params, redirect: redirect, result: result, ctx: ctx, error: null }];
                    }
                });
            });
        };
        return doRunOrResolve(path, location, ctx);
    };
    return Transition;
}());
exports.Transition = Transition;
var Router = (function () {
    function Router(_a) {
        var routes = _a.routes, _b = _a.hooks, hooks = _b === void 0 ? {} : _b, helpers = _a.helpers;
        this.isRunning = false;
        this.routes = [];
        this.hooks = hooks;
        this.helpers = helpers;
        if (Array.isArray(routes)) {
            routes = { childs: routes };
        }
        this.walk(routes);
    }
    Router.prototype.walk = function (route, walkPath) {
        if (walkPath === void 0) { walkPath = []; }
        if (route.childs) {
            walkPath.push(route);
            for (var _i = 0, _a = route.childs; _i < _a.length; _i++) {
                var child = _a[_i];
                this.walk(child, walkPath.slice());
            }
        }
        else {
            var fullWalkPath = walkPath.concat([route]);
            var middlewares = [];
            var path = '';
            for (var _b = 0, fullWalkPath_1 = fullWalkPath; _b < fullWalkPath_1.length; _b++) {
                var step = fullWalkPath_1[_b];
                if (step.path) {
                    if (step.path instanceof RegExp) {
                        path = step.path;
                    }
                    else {
                        path += "/" + trimSlashes(step.path);
                    }
                }
            }
            if (!(path instanceof RegExp)) {
                path = "/" + trimSlashes(path);
            }
            var keys = [];
            var pattern = pathToRegexp(path, keys);
            var action = route.action ? route.action : null;
            if (action) {
                for (var _c = 0, walkPath_1 = walkPath; _c < walkPath_1.length; _c++) {
                    var step = walkPath_1[_c];
                    if (step.action)
                        middlewares.push(step.action);
                }
                if (middlewares.length) {
                    for (var _d = 0, middlewares_1 = middlewares; _d < middlewares_1.length; _d++) {
                        var middleware = middlewares_1[_d];
                        action = middleware.bind(null, action);
                    }
                }
            }
            var resultRoute = __assign({}, route, { path: path,
                pattern: pattern });
            if (keys)
                resultRoute['keys'] = keys;
            if (action)
                resultRoute['action'] = action;
            this.routes.push(resultRoute);
        }
    };
    Router.prototype.matchRoute = function (path) {
        for (var _i = 0, _a = this.routes; _i < _a.length; _i++) {
            var route = _a[_i];
            var match = route.pattern.exec(path);
            if (match) {
                return { route: route, match: match, error: null };
            }
        }
        return { route: null, match: null, error: new RouterError('Not Found', 404) };
    };
    Router.prototype.checkIsRunning = function (path, ctx, isHook) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                if (this.isRunning) {
                    return [2 /*return*/, new Promise(function (resolve) { return resolve({ path: path, location: null, route: null, status: 500, params: null, redirect: null, result: null, ctx: ctx, error: new RouterError('Already running', 500) }); })];
                }
                else {
                    this.currentTransition = new Transition();
                    return [2 /*return*/, new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
                            var result, error_2;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        this.complete = resolve;
                                        this.isRunning = true;
                                        _a.label = 1;
                                    case 1:
                                        _a.trys.push([1, 3, , 4]);
                                        return [4 /*yield*/, this.currentTransition.runOrResolve(path, ctx, isHook, this)];
                                    case 2:
                                        result = _a.sent();
                                        this.isRunning = false;
                                        resolve(result);
                                        return [3 /*break*/, 4];
                                    case 3:
                                        error_2 = _a.sent();
                                        reject(error_2);
                                        return [3 /*break*/, 4];
                                    case 4: return [2 /*return*/];
                                }
                            });
                        }); })];
                }
                return [2 /*return*/];
            });
        });
    };
    Router.prototype.handleError = function (params, transition, isHooks) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!isHooks) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.runHooks('error', transition, __assign({}, params))];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/, __assign({}, params)];
                }
            });
        });
    };
    Router.prototype.runHooks = function (hook, transition, options, isHooks) {
        if (options === void 0) { options = { ctx: new Context }; }
        if (isHooks === void 0) { isHooks = true; }
        return __awaiter(this, void 0, void 0, function () {
            var _i, _a, hooks, result;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (!isHooks) return [3 /*break*/, 5];
                        _i = 0, _a = this.hooks;
                        _b.label = 1;
                    case 1:
                        if (!(_i < _a.length)) return [3 /*break*/, 5];
                        hooks = _a[_i];
                        if (!hooks[hook]) return [3 /*break*/, 4];
                        if (!(transition instanceof Transition && !transition.isCancelled)) return [3 /*break*/, 4];
                        return [4 /*yield*/, hooks[hook](options)];
                    case 2:
                        result = _b.sent();
                        if (!(result instanceof RouterError)) return [3 /*break*/, 4];
                        options.error = result;
                        options.status = result.status;
                        return [4 /*yield*/, this.handleError(options, transition, isHooks)];
                    case 3: return [2 /*return*/, _b.sent()];
                    case 4:
                        _i++;
                        return [3 /*break*/, 1];
                    case 5: return [2 /*return*/, null];
                }
            });
        });
    };
    Router.prototype.match = function (_a) {
        var path = _a.path, ctx = _a.ctx;
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var pathname, redirectHistory, doMatch, _a, route, match, status, redirect, error, params, i;
            return __generator(this, function (_b) {
                pathname = createLocation(path).pathname;
                redirectHistory = new Map();
                doMatch = function (pathname, status, redirect) {
                    if (status === void 0) { status = null; }
                    if (redirect === void 0) { redirect = null; }
                    var _a = _this.matchRoute(pathname), route = _a.route, match = _a.match, error = _a.error;
                    if (error !== null)
                        return { route: route, match: match, status: error.status, redirect: redirect, error: error };
                    if (route.status)
                        status = route.status;
                    if (route.to) {
                        if (status === null)
                            status = 302;
                        redirect = route.to;
                        if (redirectHistory.has(route)) {
                            var error_3 = new RouterError('Circular Redirect', 500);
                            return { route: route, match: match, status: error_3.status, redirect: redirect, error: error_3 };
                        }
                        else {
                            redirectHistory.set(route, true);
                            return doMatch(route.to, status, redirect);
                        }
                    }
                    else {
                        if (status === null)
                            status = 200;
                        return { route: route, match: match, status: status, redirect: redirect, error: null };
                    }
                };
                _a = doMatch(pathname), route = _a.route, match = _a.match, status = _a.status, redirect = _a.redirect, error = _a.error;
                if (error !== null) {
                    return [2 /*return*/, { route: route, status: status, redirect: redirect, error: error, params: null }];
                }
                else {
                    params = {};
                    for (i = 1; i < match.length; i += 1) {
                        params[route.keys[i - 1].name] = decodeParam(match[i]);
                    }
                    return [2 /*return*/, { route: route, status: status, redirect: redirect, error: error, params: params }];
                }
                return [2 /*return*/];
            });
        });
    };
    Router.prototype.cancel = function (isHook) {
        if (isHook === void 0) { isHook = true; }
        if (this.currentTransition !== null) {
            this.currentTransition.cancel();
            if (isHook) {
                for (var _i = 0, _a = this.hooks; _i < _a.length; _i++) {
                    var hooks = _a[_i];
                    if (hooks['cancel']) {
                        hooks['cancel']();
                    }
                }
            }
            this.complete({ error: new RouterError('Cancelled', 500) });
            this.isRunning = false;
        }
        else {
        }
    };
    Router.prototype.resolve = function (_a) {
        var path = _a.path, _b = _a.ctx, ctx = _b === void 0 ? new Context() : _b;
        return this.checkIsRunning(path, ctx, false);
    };
    Router.prototype.run = function (_a) {
        var path = _a.path, _b = _a.ctx, ctx = _b === void 0 ? new Context() : _b;
        return this.checkIsRunning(path, ctx, true);
    };
    return Router;
}());
exports.Router = Router;
//# sourceMappingURL=index.js.map